#include<graphics.h>
#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include<time.h>
#include<dos.h>
#include"mouse.c"
#include<bios.h>

#define POZADI RED
#define BARVA_KOSTKY YELLOW
//#define VZOR_KOSTKY 6 // x E <1; 11>
#define OBTIZNOST 20
#define POCET_X 10
#define POCET_Y 10

//#define S_VYPISEM

#define MAX_POLE 40
#if (POCET_X > MAX_POLE)
  #error POCET_X je moc velike!!!
#endif
#if (POCET_Y > MAX_POLE)
  #error POCET_Y je moc velike!!!
#endif

#define MEZERA 3
#define cara_x (getmaxx()/2)
#define cara_y (getmaxy()/2)
#define KOSTKA_X ((cara_x - 1)/(POCET_X) - MEZERA)
#define KOSTKA_Y ((cara_y - 1)/(POCET_Y) - MEZERA)
#define SOURADNICE_X ((getmaxx() - cara_x)/2)
#define SOURADNICE_Y ((getmaxy() - cara_y)/2)
#define PAUZA_VYPISU 10
#define PAUZA_KLIKU 250
#define MYS_CITLIVOST 2
#define TRUE 1
#define FALSE 0

// globalni funkce
int zmen_pole(int x, int y);
void kamklikxy(int x, int y, int *nove_x, int *nove_y);
void okraje(void);
void kresli_pole(void);
void vymysli_pole(void);
void nuluj_pole(void);

// globalni promene
int x_pole, y_pole;
char pole[POCET_X][POCET_Y];

char VZOR_KOSTKY;

// hlavni funkce
int main()
{
        int konec, i, mx, my, x_pole, y_pole, key, pokusu, c;
        clock_t start_cas, cas;

        /*...zavedeni grafiky...*/
        int gdriver, gmode, grchyba;
        detectgraph(&gdriver, &gmode);
        initgraph(&gdriver, &gmode, "c:\\apps\\bc\\bgi");
        grchyba = graphresult();

        if (grchyba != grOk) {
                printf("Chyba grafiky:%s\n", grapherrormsg(grchyba));
                exit(1);
        }

        /*...konec zavadeni grafiky...*/

        srand((unsigned)time(NULL));
        setbkcolor(POZADI);
        cleardevice();
        i = init_mouse();
        mouse_y_range(SOURADNICE_Y-MEZERA, SOURADNICE_Y + cara_y - MEZERA);
        mouse_x_range(SOURADNICE_X-MEZERA, SOURADNICE_X + cara_x - MEZERA);
        mouse_sensibility(MYS_CITLIVOST, MYS_CITLIVOST);
        set_mouse(getmaxx()/2, getmaxy()/2);
        okraje();

        do {
                VZOR_KOSTKY = rand()%(11) + 1;
                gotoxy(1, 1);
                printf("                                                   "
                          "                    ");

                konec = 0;
                pokusu = 0;
                x_pole = 0, y_pole = 0;
                show_mouse();

                nuluj_pole();
                vymysli_pole();
                kresli_pole();

                start_cas = clock();
                gotoxy(1, 3);
                printf("ESC - konec kola                ");

                do {
                        cas = clock();
                        i = state_mouse(&mx, &my);
                        kamklikxy(mx, my, &x_pole, &y_pole);

                        if (bioskey(1) != 0) {
                                key = bioskey(0);
                                switch (key) {
                                        case 283: //ESC - konec
                                                gotoxy(1, 3);
                                                printf("Chces skoncit toto kolo? (a/n)");
                                                c = getch();
                                                gotoxy(1, 3);
                                                printf("ESC - konec kola              ");
                                                konec = (c == 'a' ? 1 : 0);
                                                break;

                                        case 19200: //kurs. left
                                                set_mouse((x_pole - 1)*(KOSTKA_X + MEZERA + 1)
                                                + SOURADNICE_X + KOSTKA_X/2, my);
                                                break;

                                        case 19712: //kurs. right
                                                set_mouse((x_pole + 1)*(KOSTKA_X + MEZERA + 1)
                                                 + SOURADNICE_X + KOSTKA_X/2, my);
                                                break;

                                        case 18432: //kurs. up
                                                set_mouse(mx, (y_pole - 1)*(KOSTKA_Y
                                                + MEZERA + 1) + SOURADNICE_Y + KOSTKA_Y/2);
                                                break;

                                        case 20480: //kurs. down
                                                set_mouse(mx, (y_pole + 1)*(KOSTKA_Y
                                                + MEZERA + 1) + SOURADNICE_Y + KOSTKA_Y/2);
                                                break;

                                        case 7181: //enter
                                                pokusu++;
                                                konec = zmen_pole(x_pole, y_pole);
                                                kresli_pole();
                                                break;
                                }
                        }

                        if (i == 1) {
                                pokusu++;
                                konec = zmen_pole(x_pole,y_pole);
                                kresli_pole();
                                delay(PAUZA_KLIKU);
                        }

                        gotoxy(1, 1);
                        printf("x=%03d y=%03d pokusu: %d cas: %6.2f sec",
                                   x_pole+1, y_pole+1, pokusu, (cas-start_cas)
                                   / (double) CLK_TCK);

                } while (!konec); /*konec jedne hry*/

                hide_mouse();
                gotoxy(1, 3);
                printf("ESC - konec hry, jina - nova hra");

        } while (getch() != 27);

        closegraph();
        return(0);
}

int zmen_pole(int x, int y)
{
        int prazdno = 1;

                                          pole[x][y]   = 1-pole[x][y];   // doprostred
        if ((y-1) > -1)       pole[x][y-1] = 1-pole[x][y-1]; // nahoru
        if ((y+1) < POCET_Y)  pole[x][y+1] = 1-pole[x][y+1]; // dolu
        if ((x-1) > -1)       pole[x-1][y] = 1-pole[x-1][y]; // doleva
        if ((x+1) < POCET_X)  pole[x+1][y] = 1-pole[x+1][y]; // doprava

        // je pole prazdne?
        for (x=0; x<POCET_X; x++)
                for (y=0; y<POCET_Y; y++)
                        if (pole[x][y] != 0)  prazdno = 0;

        return(prazdno);
}

void nuluj_pole(void)
{
        int x, y;
        for (x=0; x<POCET_X; x++)
                for (y=0; y<POCET_Y; y++)
                        pole[x][y] = 0;
}

void kamklikxy(int x, int y, int *nove_x, int *nove_y)
{
        *nove_x = (x - SOURADNICE_X)/(KOSTKA_X + MEZERA + 1);
        *nove_y = (y - SOURADNICE_Y)/(KOSTKA_Y + MEZERA + 1);
}

void kresli_pole(void)
{
        int ckostka_x, ckostka_y;

        hide_mouse();

        for (ckostka_y=0; ckostka_y<POCET_Y; ckostka_y++)
                for (ckostka_x=0; ckostka_x<POCET_X; ckostka_x++){
                        setfillstyle(VZOR_KOSTKY, BARVA_KOSTKY
                                           * pole[ckostka_x][ckostka_y]);

                        bar(SOURADNICE_X + ckostka_x*KOSTKA_X + ckostka_x*(MEZERA + 1),
                            SOURADNICE_Y + ckostka_y*KOSTKA_Y + ckostka_y*(MEZERA + 1),
                            SOURADNICE_X + ckostka_x*KOSTKA_X + KOSTKA_X + ckostka_x
                                 *(MEZERA + 1),
                            SOURADNICE_Y + ckostka_y*KOSTKA_Y + KOSTKA_Y + ckostka_y
                                 *(MEZERA + 1));
        }

        show_mouse();
}

void vymysli_pole(void)
{
        int x, y, tahu;

        for (tahu=0; tahu<OBTIZNOST; tahu++) {
                x = rand()%(POCET_X);
                y = rand()%(POCET_Y);
                zmen_pole(x, y);

#ifdef S_VYPISEM
                printf("\n%d %d", x+1, y+1);
                kresli_pole();
                delay(PAUZA_VYPISU);
#endif
        }

}

void okraje(void)
{
        int x, y;

        setcolor(BLUE);
        setlinestyle(SOLID_LINE, 1, MEZERA);

        for (x=SOURADNICE_X-MEZERA; x <= SOURADNICE_X-MEZERA+cara_x+KOSTKA_X;
                x += KOSTKA_X+MEZERA+1) {

                line(x,SOURADNICE_Y-MEZERA,x,SOURADNICE_Y-MEZERA+cara_y);
        }

        for (y=SOURADNICE_Y-MEZERA; y <= SOURADNICE_Y-MEZERA+cara_y+KOSTKA_Y;
                y += KOSTKA_Y+MEZERA+1) {

                line(SOURADNICE_X-MEZERA,y,SOURADNICE_X-MEZERA+cara_x,y);
        }
}